const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const galleries = sequelize.define(
    'galleries',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

category: {
        type: DataTypes.ENUM,
      
      

        values: [

"farms",


"processing_stations",


"cupping_sessions",


"export_logistics",


"heritage",


"other"

        ],

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  galleries.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









    db.galleries.hasMany(db.gallery_items, {
      as: 'gallery_items_gallery',
      foreignKey: {
          name: 'galleryId',
      },
      constraints: false,
    });















//end loop



    db.galleries.belongsTo(db.pages, {
      as: 'page',
      foreignKey: {
        name: 'pageId',
      },
      constraints: false,
    });




    db.galleries.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.galleries.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return galleries;
};


